*---------------------------------------------------------------------------------------------
*
* gcc example1.s
* writing 32-bit longs to the hex display
*
* 04/05/2023 steve crompton
*
*---------------------------------------------------------------------------------------------

    .global _start

    .text

    .equ hex_display,0xAB0000

    dc.w 0x601A                     /* integer 601AH denotes text, data, and bss are contiguous */
    dc.l _end-_start                /* number of bytes in text segment */
    dc.l 0x00000000                 /* number of bytes in data segment */
    dc.l 0x00000000                 /* number of bytes in bss */
    dc.l 0x00000000                 /* number of bytes in symbol table */
    dc.l 0x00000000                 /* reserved; always zero */
    dc.l _start                     /* beginning of text segment and of program execution */
    dc.w 0xFFFF                     /* integer flag for relocation bits; */
                                    /* if 0, relocation bits exist; */
                                    /* if not 0, no relocation bits exist */

_start:

    move.l #0x12340000,%d0          /* put "12340000" on the hex display */
    move.l %d0,hex_display          /* to indicate program start */

* wait

    move.l #0x100000,%d1            /* set wait time */

delay:

    sub.l #1,%d1                    /* wait */
    bne.s delay

* wait end

    move.l #0x00005678,%d0          /* put "00005678" on the hex display */
    move.l %d0,hex_display          /* to indicate program end */

forever:

*   bra.s forever                   /* wait for reset button to be pressed */

    rts                             /* return to cp/m-68k */

_end:

    .end

*---------------------------------------------------------------------------------------------
